/*-----------------------
 * EBOLA - Ebola client.
 */
 
 
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "ebola_api.h"

#define _EBOLA_STOPPED -1
#define _EBOLA_STARTED 0

/* globacl */

int EBOLA_status = _EBOLA_STOPPED;
int client_socket;
char buffer[256];

int EBOLA_start( char *hostname, int port, char *user, char *passwd ){
	
	int remote_port, status =0;
	struct hostent *host_ptr = NULL;
	struct sockaddr_in server_name = { 0 };
	char *remote_host = NULL;
	
	remote_host = hostname;
	remote_port = port;
	
	client_socket = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
	
	if (client_socket == -1) {
		perror("socket()");
		exit(1);
		}
		
	host_ptr = gethostbyname(remote_host);
	if (host_ptr == NULL) {
		host_ptr = gethostbyaddr(remote_host, strlen(remote_host), AF_INET);
		if (host_ptr == NULL) {
			perror("Error resolving name");
			exit(1);
			}
		}
		
	server_name.sin_family = AF_INET;
	server_name.sin_port = htons(remote_port);
	memcpy(&server_name.sin_addr, host_ptr->h_addr, host_ptr->h_length);
	
	status = connect(client_socket, (struct sockaddr*) &server_name, sizeof(server_name));
	
	if (status == -1){
		perror("connect()");
		exit(1);
		}

	/* read any excess trash from socket ... */
	status=read(client_socket, buffer, sizeof(buffer) -1);
	fprintf(stderr,"Trash READ: %d bytes, %s\n",status,buffer);
#ifdef DEBUG
	fprintf(stdout,"FROM SERVER = %s\n",buffer);
#endif

	snprintf(buffer,sizeof(buffer),"user %s\n",user);
	status = write(client_socket, buffer,strlen(buffer));
	status=read(client_socket, buffer, sizeof(buffer) -1);
#ifdef DEBUG
	fprintf(stdout,"FROM SERVER = %s\n",buffer);
#endif
	snprintf(buffer,sizeof(buffer),"pass %s\n",user);
	status = write(client_socket, buffer,strlen(buffer));
	status=read(client_socket, buffer, sizeof(buffer) -1);
#ifdef DEBUG
	fprintf(stdout,"FROM SERVER = %s\n",buffer);
#endif

	EBOLA_status = _EBOLA_STARTED;
		
	return 0;
	}


	
int EBOLA_stop( void ){

	EBOLA_status = _EBOLA_STOPPED;
	write(client_socket,"quit\n\n",sizeof("quit\n\n"));
	close(client_socket);
	return 0;
	}
	

int EBOLA_scan_file( char *fname ){

	int status, result = 0;
	char outputs[10240];
				
	/*-------------------EBOLA specific code.... -------------*/

	if (EBOLA_status != _EBOLA_STARTED) {
		fprintf(stderr,"Error: EBOLA client not started, use EBOLA_start(hostname, port)\n");
		exit(1);
		}

	memset(&outputs, 0, sizeof(outputs));
	memset(&buffer, 0, sizeof(buffer));
	
	/* create and send the file scan request */	
	snprintf(outputs,sizeof(outputs),"scan %s",fname);
	write(client_socket, outputs, strlen(outputs));
	
	/* readback the virus status report */
	status = read(client_socket, buffer, sizeof(buffer) -1);
	
	if (status > -1) {
		result = atoi(buffer);
		}
	else {
		perror("Error: could not readback report");
		exit(1);
		}
			
	return result;
	}
	
